/*
 * social.c -- part of social.mod
 *        .
 *
 * Written by mrBuG	and Squash                         Apr 08 2004
 */
/*
 * Copyright (C) 2004 mrBuG <mrBuG@eggdrop.org.ru> and Squash <squash@ms.tusur.ru>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#define MODULE_VERSION "0.3b"
#define MODULE_NAME "social"
#define MAKING_SOCIAL
#include "src/mod/module.h"
#include "../channels.mod/channels.h"
#include <stdlib.h>
#include "social.h"

static p_tcl_bind_list H_pub;

static char text2[256], text4[256], text5[256], text6[256], text7[256];

#undef global
static Function *global = NULL, *channels_funcs = NULL;

char outbuf[4096];

__inline char* join_lang( char* str1, char *str2 )
{
	sprintf( (char*)outbuf, "%s%s", str1, str2 );
	return outbuf;
}

__inline char* join_lang1( char* str1, char *str2 , char *str3)
{
	sprintf( (char*)outbuf, "%s%s%s", str1, str2, str3 );
	return outbuf;
}

static int social_expmem()
{
	Context;
	return(0);
}

void strtlwr( char *in, char *out )
{
	while ( *out ) *out++ = tolower( *in++ );
}

static unsigned char botnick[NICKLEN];

static int on_pub_socmode(char *nick, char *uhost, char *hand, char *channel, char *text)
{

	char *list[2], soc_mode_error[256];
	struct chanset_t *chan = NULL; 

	sprintf(soc_mode_error, join_lang("NOTICE %s :%c%s:%c ", SOC_ERR), channel, 2, nick, 2);

	if (strlen(text) < 1) {
		dprintf(DP_SERVER, join_lang1("PRIVMSG %s :%c%s:%c ", SOC_HELP, " <notice|channel|none>%c\r\n"), channel, 2, nick, 2, 2, 2);
		Context;

		if (ngetudef("nopubsocial", channel)) {
			dprintf(DP_SERVER, join_lang1("PRIVMSG %s :%c%s:%c ", SOC_MODE, " %cnone%c\r\n"), channel, 2, nick, 2, 2, 2);
		} else {

			if (ngetudef("noquietsocial", channel)) {
				dprintf(DP_SERVER, join_lang1("PRIVMSG %s :%c%s:%c ", SOC_MODE, " %cchannel%c\r\n"), channel, 2, nick, 2, 2, 2);
			} else {
				dprintf(DP_SERVER, join_lang1("PRIVMSG %s :%c%s:%c ", SOC_MODE, " %cnotice%c\r\n"), channel, 2, nick, 2, 2, 2);
			}

		}

		return(0);
	}

	chan = findchan_by_dname(channel);

	if (!strcmp("none", text)) {
		list[0] = "-nopubsocial";
    	list[1] = "+nopubsocial";

		if (tcl_channel_modify(0, chan, 2, list) == TCL_OK ) {
			dprintf(DP_SERVER, join_lang1("PRIVMSG %s :%c%s:%c ", SOC_MODE_ADD, " %cnone%c\r\n"), channel, 2, nick, 2, 2, 2);
		} else {
			dprintf(DP_SERVER, soc_mode_error);
		}
	
	} else {

		if (!strcmp("channel", text)) {
			list[0] = "+nopubsocial";
    		list[1] = "-nopubsocial";

    		if (tcl_channel_modify(0, chan, 2, list) == TCL_OK ) {
				list[0] = "-noquietsocial";
    			list[1] = "+noquietsocial";

    			if (tcl_channel_modify(0, chan, 2, list) == TCL_OK ) {
					dprintf(DP_SERVER, join_lang1("PRIVMSG %s :%c%s:%c ", SOC_MODE_ADD, " %cchannel%c\r\n"), channel, 2, nick, 2, 2, 2);
				} else {
					dprintf(DP_SERVER, soc_mode_error);
				}

    		}

		} else {

			if (!strcmp("notice", text)) {
				list[0] = "+nopubsocial";
    			list[1] = "-nopubsocial";

    			if (tcl_channel_modify(0, chan, 2, list) == TCL_OK ) {
					list[0] = "+noquietsocial";
    				list[1] = "-noquietsocial";

    				if (tcl_channel_modify(0, chan, 2, list) == TCL_OK ) {
						dprintf(DP_SERVER, join_lang1("PRIVMSG %s :%c%s:%c ", SOC_MODE_ADD, " %cnotice%c\r\n"), channel, 2, nick, 2, 2, 2);
					} else {
						dprintf(DP_SERVER, soc_mode_error);
					}

    			}

			} else {
				dprintf(DP_SERVER, join_lang1("PRIVMSG %s :%c%s:%c ", SOC_MODE_ERR, " <notice|channel|none>%c\r\n"), channel, 2, nick, 2, 2, 2);
			}

		}

	}

	putlog(LOG_CMDS, "*", "pub:socmode [%s(%s): %s] %s", nick, hand, channel, text);
	return(0);
}

static int on_pub_social(char *text1, char *text2, char *text3, char *text4, char *text5, char *text6, char *text7, char *text8, char *nck, char *chnnl, char *inpt)
{
	memberlist *m;
	struct chanset_t *chan;
	char botnc[2048], inp[2048], nc[2048];
	Context;

	if (ngetudef("nopubsocial", chnnl))
	    return (0); 

	chan = findchan(chnnl);    
    
    m = ismember(chan, inpt);

	strtlwr(botnick, botnc);
	strtlwr(inpt, inp);
	strtlwr(nck, nc);


	if (m && !strcmp(nck, m->nick)) {

		if (ngetudef("noquietsocial", chnnl)) {
			dprintf(DP_SERVER, "privmsg %s :%cACTION %c::%c %s%c\r\n", chnnl, 1, 2, 2, text2, 1);
    		return (0);
    	}

		dprintf(DP_SERVER, "notice %s :%s\r\n", nck, text1);
		dprintf(DP_SERVER, "privmsg %s :%cACTION %c::%c %s%c\r\n", chnnl, 1, 2, 2, text2, 1);
		return(0);

	}

	if (strlen(inpt) < 1) {

		if (ngetudef("noquietsocial", chnnl)) {
			dprintf(DP_SERVER, "privmsg %s :%cACTION %c::%c %s%c\r\n", chnnl, 1, 2, 2, text4, 1);
		} else {
			dprintf(DP_SERVER, "notice %s :%s\r\n", nck, text3);
			dprintf(DP_SERVER, "privmsg %s :%cACTION %c::%c %s%c\r\n", chnnl, 1, 2, 2, text4, 1);
		}

	} else {

   		if (m) {

			if (!strcmp(botnick, m->nick)) {
				
				dprintf(DP_SERVER, join_lang("NOTICE %s :", SOC_BNC_NCK), nck);
				return (0);
				
			} else {		

				if (ngetudef("noquietsocial", chnnl)) {
					dprintf(DP_SERVER, "privmsg %s :%cACTION %c::%c %s%c\r\n", chnnl, 1, 2, 2, text6, 1);
					return(0);
				}

   				dprintf(DP_SERVER, "notice %s :%s\r\n", nck, text5);
   				dprintf(DP_SERVER, "privmsg %s :%cACTION %c::%c %s%c\r\n", chnnl, 1, 2, 2, text6, 1);
   				dprintf(DP_SERVER, "notice %s :%s\r\n", inpt, text7);
  				return(0);

   			}
		} else {
			dprintf(DP_SERVER, "notice %s :%s\r\n", nck, text8);
			return(0);
   		}
   	}
	

	return(0);
}

/* BOUNCE */
static int on_pub_bounce(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "        ."; */

	sprintf((char*)text2, BNC2, nick);

/*	char text3[256] = "BOIINNNNNNGG!"; */

	sprintf((char*)text4, BNC4, nick);

	sprintf((char*)text5, BNC5, text);

	sprintf((char*)text6, BNC6, nick, text);

	sprintf((char*)text7, BNC7, nick);

/*	char text8[256] = "     ."; */

	putlog(LOG_CMDS, "*", "pub:bounce [%s: %s] %s", nick, channel, text);
	on_pub_social(BNC1, text2, BNC3, text4, text5, text6, text7, BNC8, nick, channel, text);

	return(0);
}

/* SMILE */
static int on_pub_smile(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ."; */

	sprintf((char*)text2, SML2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, SML4, nick);

	sprintf((char*)text5, SML5, text);

	sprintf((char*)text6, SML6, nick, text);

	sprintf((char*)text7, SML7, nick);

/*	char text8[256] = "     ..."; */

	putlog(LOG_CMDS, "*", "pub:smile [%s: %s] %s", nick, channel, text);
	on_pub_social(SML1, text2, SML3, text4, text5, text6, text7, SML8, nick, channel, text);

	return(0);
}

/* DANCE */
static int on_pub_dance(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "     ."; */

	sprintf((char*)text2, DNC2, nick);

/*	char text3[256] = "  ,   ?"; */

	sprintf((char*)text4, DNC4, nick);

	sprintf((char*)text5, DNC5, text);

	sprintf((char*)text6, DNC6, nick, text);

	sprintf((char*)text7, DNC7, nick);

/*	char text8[256] = ",  ?"; */

	putlog(LOG_CMDS, "*", "pub:dance [%s: %s] %s", nick, channel, text);
	on_pub_social(DNC1, text2, DNC3, text4, text5, text6, text7, DNC8, nick, channel, text);

	return(0);
}

/* TANGO */
static int on_pub_tango(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ,   ?"; */

	sprintf((char*)text2, TNG2, nick);

/*	char text3[256] = "    , ?"; */

	sprintf((char*)text4, TNG4, nick);

	sprintf((char*)text5, TNG5, text);

	sprintf((char*)text6, TNG6, nick, text);

	sprintf((char*)text7, TNG7, nick);

/*	char text8[256] = "  .   ."; */

	putlog(LOG_CMDS, "*", "pub:tango [%s: %s] %s", nick, channel, text);
	on_pub_social(TNG1, text2, TNG3, text4, text5, text6, text7, TNG8, nick, channel, text);

	return(0);
}

/* CACKLE */
static int on_pub_cackle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   .   -  ."; */

	sprintf((char*)text2, CCK2, nick, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, CCK4, nick);

	sprintf((char*)text5, CCK5, text);

	sprintf((char*)text6, CCK6, nick, text);

	sprintf((char*)text7, CCK7, nick, nick);

/*	char text8[256] = "   ,   ."; */

	putlog(LOG_CMDS, "*", "pub:cackle [%s: %s] %s", nick, channel, text);
	on_pub_social(CCK1, text2, CCK3, text4, text5, text6, text7, CCK8, nick, channel, text);

	return(0);
}

/* LAUGH */
static int on_pub_laugh(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   .   ."; */

	sprintf((char*)text2, LGH2, nick);

/*	char text3[256] = "     ."; */

	sprintf((char*)text4, LGH4, nick);

	sprintf((char*)text5, LGH5, text);

	sprintf((char*)text6, LGH6, nick, text);

	sprintf((char*)text7, LGH7, nick);

/*	char text8[256] = "       ."; */

	putlog(LOG_CMDS, "*", "pub:laugh [%s: %s] %s", nick, channel, text);
	on_pub_social(LGH1, text2, LGH3, text4, text5, text6, text7, LGH8, nick, channel, text);

	return(0);
}

/* GIGGLE */
static int on_pub_giggle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ,    , ..."; */

	sprintf((char*)text2, GGG2, nick, nick);

/*	char text3[256] = " ."; */

	sprintf((char*)text4, GGG4, nick);

	sprintf((char*)text5, GGG5, text);

	sprintf((char*)text6, GGG6, nick, text);

	sprintf((char*)text7, GGG7, nick);

/*	char text8[256] = "    ,      ."; */

	putlog(LOG_CMDS, "*", "pub:giggle [%s: %s] %s", nick, channel, text);
	on_pub_social(GGG1, text2, GGG3, text4, text5, text6, text7, GGG8, nick, channel, text);

	return(0);
}

/* SHAKE */
static int on_pub_shake(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ."; */

	sprintf((char*)text2, SHK2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, SHK4, nick);

	sprintf((char*)text5, SHK5, text);

	sprintf((char*)text6, SHK6, nick, text);

	sprintf((char*)text7, SHK7, nick);

/*	char text8[256] = " ,     ."; */

	putlog(LOG_CMDS, "*", "pub:shake [%s: %s] %s", nick, channel, text);
	on_pub_social(SHK1, text2, SHK3, text4, text5, text6, text7, SHK8, nick, channel, text);

	return(0);
}

/* PUKE */
static int on_pub_puke(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, PUK2, nick);

/*	char text3[256] = " ... !!! --!"; */

	sprintf((char*)text4, PUK4, nick);

	sprintf((char*)text5, PUK5, text);

	sprintf((char*)text6, PUK6, nick, text);

	sprintf((char*)text7, PUK7, nick, nick);

/*	char text8[256] = " ?"; */

	putlog(LOG_CMDS, "*", "pub:puke [%s: %s] %s", nick, channel, text);
	on_pub_social(PUK1, text2, PUK3, text4, text5, text6, text7, PUK8, nick, channel, text);

	return(0);
}

/* GROWL */
static int on_pub_growl(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   . ,   ."; */

	sprintf((char*)text2, GRW2, nick);

/*	char text3[256] = "..."; */

	sprintf((char*)text4, GRW4, nick);

	sprintf((char*)text5, GRW5, text);

	sprintf((char*)text6, GRW6, nick, text);

	sprintf((char*)text7, GRW7, nick);

/*	char text8[256] = "     ."; */

	putlog(LOG_CMDS, "*", "pub:growl [%s: %s] %s", nick, channel, text);
	on_pub_social(GRW1, text2, GRW3, text4, text5, text6, text7, GRW8, nick, channel, text);

	return(0);
}

/* SCREAM */
static int on_pub_scream(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   . ,      ."; */

	sprintf((char*)text2, SCR2, nick);

/*	char text3[256] = "-----!!!!!"; */

	sprintf((char*)text4, SCR4, nick);

	sprintf((char*)text5, SCR5, text);

	sprintf((char*)text6, SCR6, nick, text, nick);

	sprintf((char*)text7, SCR7, nick);

/*	char text8[256] = "    !"; */

	putlog(LOG_CMDS, "*", "pub:scream [%s: %s] %s", nick, channel, text);
	on_pub_social(SCR1, text2, SCR3, text4, text5, text6, text7, SCR8, nick, channel, text);

	return(0);
}

/* COMFORT */
static int on_pub_comfort(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ."; */

	sprintf((char*)text2, CMF2, nick);

/*	char text3[256] = " ?"; */

	sprintf((char*)text4, CMF4, nick);

	sprintf((char*)text5, CMF5, text);

	sprintf((char*)text6, CMF6, nick, text);

	sprintf((char*)text7, CMF7, nick);

/*	char text8[256] = " ?"; */

	putlog(LOG_CMDS, "*", "pub:comfort [%s: %s] %s", nick, channel, text);
	on_pub_social(CMF1, text2, CMF3, text4, text5, text6, text7, CMF8, nick, channel, text);

	return(0);
}

/* SIGH */
static int on_pub_sigh(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  .   ."; */

	sprintf((char*)text2, SGH2, nick);

/*	char text3[256] = " ."; */

	sprintf((char*)text4, SGH4, nick);

	sprintf((char*)text5, SGH5, text);

	sprintf((char*)text6, SGH6, nick, text);

	sprintf((char*)text7, SGH7, nick);

/*	char text8[256] = "  ,    ."; */

	putlog(LOG_CMDS, "*", "pub:sigh [%s: %s] %s", nick, channel, text);
	on_pub_social(SGH1, text2, SGH3, text4, text5, text6, text7, SGH8, nick, channel, text);

	return(0);
}

/*
 * static int on_pub_sulk(char *nick, char *uhost, char *hand, char *channel, char *text)
 * {
 * 	dprintf(DP_SERVER, "notice %s :   .\r\n", nick);
 * 	dprintf(DP_SERVER, "privmsg %s :%cACTION %c::%c %s   .%c\r\n", channel, 1, 2, 2, nick, 1);
 * 	
 *	putlog(LOG_CMDS, "*", "pub:sulk [%s: %s] %s", nick, channel, text);
 * 
 * 	return(0);
 * }
 */

/* HUG */
static int on_pub_hug(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ."; */

	sprintf((char*)text2, HUG2, nick);

/*	char text3[256] = " ?"; */

	sprintf((char*)text4, HUG4, nick);

	sprintf((char*)text5, HUG5, text);

	sprintf((char*)text6, HUG6, nick, text);

	sprintf((char*)text7, HUG7, nick);

/*	char text8[256] = ", ,   ."; */

	putlog(LOG_CMDS, "*", "pub:hug [%s: %s] %s", nick, channel, text);
	on_pub_social(HUG1, text2, HUG3, text4, text5, text6, text7, HUG8, nick, channel, text);

	return(0);
}

/* SNUGGLE */
static int on_pub_snuggle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ,   ."; */

	sprintf((char*)text2, SNG2, nick);

/*	char text3[256] = "?"; */

	sprintf((char*)text4, SNG4, nick);

	sprintf((char*)text5, SNG5, text);

	sprintf((char*)text6, SNG6, nick, text);

	sprintf((char*)text7, SNG7, nick);

/*	char text8[256] = "  ."; */

	putlog(LOG_CMDS, "*", "pub:snuggle [%s: %s] %s", nick, channel, text);
	on_pub_social(SNG1, text2, SNG3, text4, text5, text6, text7, SNG8, nick, channel, text);

	return(0);
}

/* CUDDLE */
static int on_pub_cuddle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "      :)"; */

	sprintf((char*)text2, CDD2, nick);

/*	char text3[256] = "     ?"; */

	sprintf((char*)text4, CDD4, nick);

	sprintf((char*)text5, CDD5, text);

	sprintf((char*)text6, CDD6, nick, text);

	sprintf((char*)text7, CDD7, nick);

/*	char text8[256] = "  ."; */

	putlog(LOG_CMDS, "*", "pub:cuddle [%s: %s] %s", nick, channel, text);
	on_pub_social(CDD1, text2, CDD3, text4, text5, text6, text7, CDD8, nick, channel, text);

	return(0);
}

/* NUZZLE */
static int on_pub_nuzzle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = ", ,   ."; */

	sprintf((char*)text2, NZZ2, nick);

/*	char text3[256] = "?"; */

	sprintf((char*)text4, NZZ4, nick);

	sprintf((char*)text5, NZZ5, text);

	sprintf((char*)text6, NZZ6, nick, text);

	sprintf((char*)text7, NZZ7, nick);

/*	char text8[256] = "...   ..."; */

	putlog(LOG_CMDS, "*", "pub:nuzzle [%s: %s] %s", nick, channel, text);
	on_pub_social(NZZ1, text2, NZZ3, text4, text5, text6, text7, NZZ8, nick, channel, text);

	return(0);
}

/* CRY */
static int on_pub_cry(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, CRY2, nick);

/*	char text3[256] = "--..--.."; */

	sprintf((char*)text4, CRY4, nick);

	sprintf((char*)text5, CRY5, text);

	sprintf((char*)text6, CRY6, nick, text);

	sprintf((char*)text7, CRY7, nick);

/*	char text8[256] = "?"; */

	putlog(LOG_CMDS, "*", "pub:cry [%s: %s] %s", nick, channel, text);
	on_pub_social(CRY1, text2, CRY3, text4, text5, text6, text7, CRY8, nick, channel, text);

	return(0);
}

/* POKE */
static int on_pub_poke(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ,    ."; */

	sprintf((char*)text2, POK2, nick);

/*	char text3[256] = " ??"; */

	sprintf((char*)text4, POK4, nick);

	sprintf((char*)text5, POK5, text);

	sprintf((char*)text6, POK6, nick, text);

	sprintf((char*)text7, POK7, nick);

/*	char text8[256] = "    ,   ."; */

	putlog(LOG_CMDS, "*", "pub:poke [%s: %s] %s", nick, channel, text);
	on_pub_social(POK1, text2, POK3, text4, text5, text6, text7, POK8, nick, channel, text);

	return(0);
}

/* ACCUSE */
static int on_pub_accuse(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ."; */

	sprintf((char*)text2, ACC2, nick);

/*	char text3[256] = " ??"; */

	sprintf((char*)text4, ACC4, nick);

	sprintf((char*)text5, ACC5, text);

	sprintf((char*)text6, ACC6, nick, text);

	sprintf((char*)text7, ACC7, nick);

/*	char text8[256] = " -,   ?"; */

	putlog(LOG_CMDS, "*", "pub:accuse [%s: %s] %s", nick, channel, text);
	on_pub_social(ACC1, text2, ACC3, text4, text5, text6, text7, ACC8, nick, channel, text);

	return(0);
}

/* GRIN */
static int on_pub_grin(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   .  ,     ."; */

	sprintf((char*)text2, GRN2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, GRN4, nick);

	sprintf((char*)text5, GRN5, text);

	sprintf((char*)text6, GRN6, nick, text);

	sprintf((char*)text7, GRN7, nick);

/*	char text8[256] = "  ,  ."; */

	putlog(LOG_CMDS, "*", "pub:grin [%s: %s] %s", nick, channel, text);
	on_pub_social(GRN1, text2, GRN3, text4, text5, text6, text7, GRN8, nick, channel, text);

	return(0);
}

/* BOW */
static int on_pub_bow(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ."; */

	sprintf((char*)text2, BOW2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, BOW4, nick);

	sprintf((char*)text5, BOW5, text);

	sprintf((char*)text6, BOW6, nick, text);

	sprintf((char*)text7, BOW7, nick);

/*	char text8[256] = "?"; */

	putlog(LOG_CMDS, "*", "pub:bow [%s: %s] %s", nick, channel, text);
	on_pub_social(BOW1, text2, BOW3, text4, text5, text6, text7, BOW8, nick, channel, text);

	return(0);
}

/* APPLAUD */
static int on_pub_applaud(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  . ,   ."; */

	sprintf((char*)text2, APP2, nick);

/*	char text3[256] = ", , ."; */

	sprintf((char*)text4, APP4, nick);

	sprintf((char*)text5, APP5, text);

	sprintf((char*)text6, APP6, nick, text);

	sprintf((char*)text7, APP7, nick);

/*	char text8[256] = "    ."; */

	putlog(LOG_CMDS, "*", "pub:applaud [%s: %s] %s", nick, channel, text);
	on_pub_social(APP1, text2, APP3, text4, text5, text6, text7, APP8, nick, channel, text);

	return(0);
}

/* SNICKER */
static int on_pub_snicker(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ,   ."; */

	sprintf((char*)text2, SNC2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, SNC4, nick);

	sprintf((char*)text5, SNC5, text);

	sprintf((char*)text6, SNC6, nick, text);

	sprintf((char*)text7, SNC7, nick);

/*	char text8[256] = "?"; */

	putlog(LOG_CMDS, "*", "pub:snicker [%s: %s] %s", nick, channel, text);
	on_pub_social(SNC1, text2, SNC3, text4, text5, text6, text7, SNC8, nick, channel, text);

	return(0);
}

/* BLUSH */
static int on_pub_blush(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ."; */

	sprintf((char*)text2, BLS2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, BLS4, nick);

	sprintf((char*)text5, BLS5, text);

	sprintf((char*)text6, BLS6, nick, text);

	sprintf((char*)text7, BLS7, nick);

/*	char text8[256] = " ,  ,     ."; */

	putlog(LOG_CMDS, "*", "pub:blush [%s: %s] %s", nick, channel, text);
	on_pub_social(BLS1, text2, BLS3, text4, text5, text6, text7, BLS8, nick, channel, text);

	return(0);
}

/* BURP */
static int on_pub_burp(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, BRP2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, BRP4, nick);

	sprintf((char*)text5, BRP5, text);

	sprintf((char*)text6, BRP6, nick, text);

	sprintf((char*)text7, BRP7, nick);

/*	char text8[256] = "     ."; */

	putlog(LOG_CMDS, "*", "pub:burp [%s: %s] %s", nick, channel, text);
	on_pub_social(BRP1, text2, BRP3, text4, text5, text6, text7, BRP8, nick, channel, text);

	return(0);
}

/* CLAP */
static int on_pub_clap(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "     ."; */

	sprintf((char*)text2, CLP2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, CLP4, nick);

	sprintf((char*)text5, CLP5, text);

	sprintf((char*)text6, CLP6, nick, text);

	sprintf((char*)text7, CLP7, nick);

/*	char text8[256] = "   ."; */

	putlog(LOG_CMDS, "*", "pub:clap [%s: %s] %s", nick, channel, text);
	on_pub_social(CLP1, text2, CLP3, text4, text5, text6, text7, CLP8, nick, channel, text);

	return(0);
}

/* CURTSEY */
static int on_pub_curtsey(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, CUR2, nick);

/*	char text3[256] = "      ."; */

	sprintf((char*)text4, CUR4, nick);

	sprintf((char*)text5, CUR5, text);

	sprintf((char*)text6, CUR6, nick, text);

	sprintf((char*)text7, CUR7, nick);

/*	char text8[256] = "    ."; */

	putlog(LOG_CMDS, "*", "pub:curtsey [%s: %s] %s", nick, channel, text);
	on_pub_social(CUR1, text2, CUR3, text4, text5, text6, text7, CUR8, nick, channel, text);

	return(0);
}

/* FONDLE */
static int on_pub_fondle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ,  , ?"; */

	sprintf((char*)text2, FND2, nick);

/*	char text3[256] = "  ?"; */

	sprintf((char*)text4, FND4, nick);

	sprintf((char*)text5, FND5, text);

	sprintf((char*)text6, FND6, nick, text);

	sprintf((char*)text7, FND7, nick);

/*	char text8[256] = "   ,   ."; */

	putlog(LOG_CMDS, "*", "pub:fondle [%s: %s] %s", nick, channel, text);
	on_pub_social(FND1, text2, FND3, text4, text5, text6, text7, FND8, nick, channel, text);

	return(0);
}

/* GLARE */
static int on_pub_glare(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "     ."; */

	sprintf((char*)text2, GLR2, nick);

/*	char text3[256] = "    p."; */

	sprintf((char*)text4, GLR4, nick);

	sprintf((char*)text5, GLR5, text);

	sprintf((char*)text6, GLR6, nick, text);

	sprintf((char*)text7, GLR7, nick);

/*	char text8[256] = "     -,   ."; */

	putlog(LOG_CMDS, "*", "pub:glare [%s: %s] %s", nick, channel, text);
	on_pub_social(GLR1, text2, GLR3, text4, text5, text6, text7, GLR8, nick, channel, text);

	return(0);
}

/* GROAN */
static int on_pub_groan(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = " ,    ."; */

	sprintf((char*)text2, GRO2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, GRO4, nick);

	sprintf((char*)text5, GRO5, text);

	sprintf((char*)text6, GRO6, nick, text);

	sprintf((char*)text7, GRO7, nick);

/*	char text8[256] = "  ."; */

	putlog(LOG_CMDS, "*", "pub:groan [%s: %s] %s", nick, channel, text);
	on_pub_social(GRO1, text2, GRO3, text4, text5, text6, text7, GRO8, nick, channel, text);

	return(0);
}

/* GROPE */
static int on_pub_grope(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   - ."; */

	sprintf((char*)text2, GRP2, nick);

/*	char text3[256] = "   ?"; */

	sprintf((char*)text4, GRP4, nick);

	sprintf((char*)text5, GRP5, text);

	sprintf((char*)text6, GRP6, nick, text);

	sprintf((char*)text7, GRP7, nick);

/*	char text8[256] = " ,   ."; */

	putlog(LOG_CMDS, "*", "pub:grope [%s: %s] %s", nick, channel, text);
	on_pub_social(GRP1, text2, GRP3, text4, text5, text6, text7, GRP8, nick, channel, text);

	return(0);
}

/* LICK */
static int on_pub_lick(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, LCK2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, LCK4, nick);

	sprintf((char*)text5, LCK5, text);

	sprintf((char*)text6, LCK6, nick, text);

	sprintf((char*)text7, LCK7, nick);

/*	char text8[256] = "   ."; */

	putlog(LOG_CMDS, "*", "pub:lick [%s: %s] %s", nick, channel, text);
	on_pub_social(LCK1, text2, LCK3, text4, text5, text6, text7, LCK8, nick, channel, text);

	return(0);
}

/* RUFFLE */
static int on_pub_ruffle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   , ,      ,    ,    ."; */

	sprintf((char*)text2, RFF2, nick);

/*	char text3[256] = "  - ."; */

	sprintf((char*)text4, RFF4, nick);

	sprintf((char*)text5, RFF5, text);

	sprintf((char*)text6, RFF6, nick, text);

	sprintf((char*)text7, RFF7, nick);

/*	char text8[256] = " ."; */

	putlog(LOG_CMDS, "*", "pub:ruffle [%s: %s] %s", nick, channel, text);
	on_pub_social(RFF1, text2, RFF3, text4, text5, text6, text7, RFF8, nick, channel, text);

	return(0);
}

/* SHIVER */
static int on_pub_shiver(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ?"; */

	sprintf((char*)text2, SHV2, nick);

/*	char text3[256] = "."; */

	sprintf((char*)text4, SHV4, nick);

	sprintf((char*)text5, SHV5, text);

	sprintf((char*)text6, SHV6, nick, text);

	sprintf((char*)text7, SHV7, nick);

/*	char text8[256] = "  ."; */

	putlog(LOG_CMDS, "*", "pub:shiver [%s: %s] %s", nick, channel, text);
	on_pub_social(SHV1, text2, SHV3, text4, text5, text6, text7, SHV8, nick, channel, text);

	return(0);
}

/* SHRUG */
static int on_pub_shrug(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, SHR2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, SHR4, nick);

	sprintf((char*)text5, SHR5, text);

	sprintf((char*)text6, SHR6, nick, text);

	sprintf((char*)text7, SHR7, nick);

/*	char text8[256] = "  ."; */

	putlog(LOG_CMDS, "*", "pub:shrug [%s: %s] %s", nick, channel, text);
	on_pub_social(SHR1, text2, SHR3, text4, text5, text6, text7, SHR8, nick, channel, text);

	return(0);
}

/* HZ */
static int on_pub_hz(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ?   ? ..."; */

	sprintf((char*)text2, HBZ2, nick);

/*	char text3[256] = "       ."; */

	sprintf((char*)text4, HBZ4, nick);

	sprintf((char*)text5, HBZ5, text);

	sprintf((char*)text6, HBZ6, nick, text);

	sprintf((char*)text7, HBZ7, nick);

/*	char text8[256] = "     ..."; */

	putlog(LOG_CMDS, "*", "pub:hz [%s: %s] %s", nick, channel, text);
	on_pub_social(HBZ1, text2, HBZ3, text4, text5, text6, text7, HBZ8, nick, channel, text);

	return(0);
}

/* SLAP */
static int on_pub_slap(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ,  !"; */

	sprintf((char*)text2, SLP2, nick);

/*	char text3[256] = "     ."; */

	sprintf((char*)text4, SLP4, nick);

	sprintf((char*)text5, SLP5, text);

	sprintf((char*)text6, SLP6, nick, text);

	sprintf((char*)text7, SLP7, nick);

/*	char text8[256] = "   ?"; */

	putlog(LOG_CMDS, "*", "pub:slap [%s: %s] %s", nick, channel, text);
	on_pub_social(SLP1, text2, SLP3, text4, text5, text6, text7, SLP8, nick, channel, text);

	return(0);
}

/* SMIRK */
static int on_pub_smirk(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  . -....."; */

	sprintf((char*)text2, SMR2, nick);

/*	char text3[256] = " ."; */

	sprintf((char*)text4, SMR4, nick);

	sprintf((char*)text5, SMR5, text);

	sprintf((char*)text6, SMR6, nick, text);

	sprintf((char*)text7, SMR7, nick);

/*	char text8[256] = "  ?"; */

	putlog(LOG_CMDS, "*", "pub:smirk [%s: %s] %s", nick, channel, text);
	on_pub_social(SMR1, text2, SMR3, text4, text5, text6, text7, SMR8, nick, channel, text);

	return(0);
}

/* SNAP */
static int on_pub_snap(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ."; */

	sprintf((char*)text2, SNP2, nick);

/*	char text3[256] = "!   ."; */

	sprintf((char*)text4, SNP4, nick);

	sprintf((char*)text5, SNP5, text);

	sprintf((char*)text6, SNP6, nick, text);

	sprintf((char*)text7, SNP7, nick);

/*	char text8[256] = "     ."; */

	putlog(LOG_CMDS, "*", "pub:snap [%s: %s] %s", nick, channel, text);
	on_pub_social(SNP1, text2, SNP3, text4, text5, text6, text7, SNP8, nick, channel, text);

	return(0);
}

/* SNIFF */
static int on_pub_sniff(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ,    ."; */

	sprintf((char*)text2, SNF2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, SNF4, nick);

	sprintf((char*)text5, SNF5, text);

	sprintf((char*)text6, SNF6, nick, text);

	sprintf((char*)text7, SNF7, nick);

/*	char text8[256] = " ."; */

	putlog(LOG_CMDS, "*", "pub:sniff [%s: %s] %s", nick, channel, text);
	on_pub_social(SNF1, text2, SNF3, text4, text5, text6, text7, SNF8, nick, channel, text);

	return(0);
}

/* FROWN */
static int on_pub_frown(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   .  ..."; */

	sprintf((char*)text2, FRW2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, FRW4, nick);

	sprintf((char*)text5, FRW5, text);

	sprintf((char*)text6, FRW6, nick, text);

	sprintf((char*)text7, FRW7, nick);

/*	char text8[256] = "    ..."; */

	putlog(LOG_CMDS, "*", "pub:frown [%s: %s] %s", nick, channel, text);
	on_pub_social(FRW1, text2, FRW3, text4, text5, text6, text7, FRW8, nick, channel, text);

	return(0);
}

/* WHISTLE */
static int on_pub_whistle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = " ,    ."; */

	sprintf((char*)text2, WHS2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, WHS4, nick);

	sprintf((char*)text5, WHS5, text);

	sprintf((char*)text6, WHS6, nick, text);

	sprintf((char*)text7, WHS7, nick);

/*	char text8[256] = "..."; */

	putlog(LOG_CMDS, "*", "pub:whistle [%s: %s] %s", nick, channel, text);
	on_pub_social(WHS1, text2, WHS3, text4, text5, text6, text7, WHS8, nick, channel, text);

	return(0);
}

/* PONDER */
static int on_pub_ponder(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "     ."; */

	sprintf((char*)text2, PND2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, PND4, nick);

	sprintf((char*)text5, PND5, text);

	sprintf((char*)text6, PND6, nick, text);

	sprintf((char*)text7, PND7, nick);

/*	char text8[256] = "  ..."; */

	putlog(LOG_CMDS, "*", "pub:ponder [%s: %s] %s", nick, channel, text);
	on_pub_social(PND1, text2, PND3, text4, text5, text6, text7, PND8, nick, channel, text);

	return(0);
}

/* STARE */
static int on_pub_stare(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "     -  ."; */

	sprintf((char*)text2, STA2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, STA4, nick);

	sprintf((char*)text5, STA5, text);

	sprintf((char*)text6, STA6, nick, text);

	sprintf((char*)text7, STA7, nick);

/*	char text8[256] = "   ,     ."; */

	putlog(LOG_CMDS, "*", "pub:stare [%s: %s] %s", nick, channel, text);
	on_pub_social(STA1, text2, STA3, text4, text5, text6, text7, STA8, nick, channel, text);

	return(0);
}

/* STRUT */
static int on_pub_strut(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, STU2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, STU4, nick);

	sprintf((char*)text5, STU5, text);

	sprintf((char*)text6, STU6, nick, text);

	sprintf((char*)text7, STU7, nick);

/*	char text8[256] = "      ."; */

	putlog(LOG_CMDS, "*", "pub:strut [%s: %s] %s", nick, channel, text);
	on_pub_social(STU1, text2, STU3, text4, text5, text6, text7, STU8, nick, channel, text);

	return(0);
}

/* THANK */
static int on_pub_thank(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ,   !"; */

	sprintf((char*)text2, THN2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, THN4, nick);

	sprintf((char*)text5, THN5, text);

	sprintf((char*)text6, THN6, nick, text);

	sprintf((char*)text7, THN7, nick);

/*	char text8[256] = "     ."; */

	putlog(LOG_CMDS, "*", "pub:thank [%s: %s] %s", nick, channel, text);
	on_pub_social(THN1, text2, THN3, text4, text5, text6, text7, THN8, nick, channel, text);

	return(0);
}

/* TWIDDLE */
static int on_pub_twiddle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "      ."; */

	sprintf((char*)text2, TWD2, nick);

/*	char text3[256] = "    ."; */

	sprintf((char*)text4, TWD4, nick);

	sprintf((char*)text5, TWD5, text);

	sprintf((char*)text6, TWD6, nick, text);

	sprintf((char*)text7, TWD7, nick);

/*	char text8[256] = "   ."; */

	putlog(LOG_CMDS, "*", "pub:twiddle [%s: %s] %s", nick, channel, text);
	on_pub_social(TWD1, text2, TWD3, text4, text5, text6, text7, TWD8, nick, channel, text);

	return(0);
}

/* WAVE */
static int on_pub_wave(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ??  ??"; */

	sprintf((char*)text2, WAV2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, WAV4, nick);

	sprintf((char*)text5, WAV5, text);

	sprintf((char*)text6, WAV6, nick, text);

	sprintf((char*)text7, WAV7, nick);

/*	char text8[256] = "    ."; */

	putlog(LOG_CMDS, "*", "pub:wave [%s: %s] %s", nick, channel, text);
	on_pub_social(WAV1, text2, WAV3, text4, text5, text6, text7, WAV8, nick, channel, text);

	return(0);
}

/* WINK */
static int on_pub_wink(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ?? - ?"; */

	sprintf((char*)text2, WNK2, nick);

/*	char text3[256] = "-   ?"; */

	sprintf((char*)text4, WNK4, nick);

	sprintf((char*)text5, WNK5, text);

	sprintf((char*)text6, WNK6, nick, text);

	sprintf((char*)text7, WNK7, nick);

/*	char text8[256] = "    ."; */

	putlog(LOG_CMDS, "*", "pub:wink [%s: %s] %s", nick, channel, text);
	on_pub_social(WNK1, text2, WNK3, text4, text5, text6, text7, WNK8, nick, channel, text);

	return(0);
}

/* FRENCH */
static int on_pub_french(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ...."; */

	sprintf((char*)text2, FRN2, nick);

/*	char text3[256] = " ?"; */

	sprintf((char*)text4, FRN4, nick);

	sprintf((char*)text5, FRN5, text);

	sprintf((char*)text6, FRN6, nick, text);

	sprintf((char*)text7, FRN7, nick);

/*	char text8[256] = "   ,      ."; */

	putlog(LOG_CMDS, "*", "pub:french [%s: %s] %s", nick, channel, text);
	on_pub_social(FRN1, text2, FRN3, text4, text5, text6, text7, FRN8, nick, channel, text);

	return(0);
}

/* COMB */
static int on_pub_comb(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ,     ."; */

	sprintf((char*)text2, CMB2, nick);

/*	char text3[256] = "    - ."; */

	sprintf((char*)text4, CMB4, nick);

	sprintf((char*)text5, CMB5, text);

	sprintf((char*)text6, CMB6, nick, text);

	sprintf((char*)text7, CMB7, nick);

/*	char text8[256] = "  ."; */

	putlog(LOG_CMDS, "*", "pub:comb [%s: %s] %s", nick, channel, text);
	on_pub_social(CMB1, text2, CMB3, text4, text5, text6, text7, CMB8, nick, channel, text);

	return(0);
}

/* MASSAGE */
static int on_pub_massage(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "        ."; */

	sprintf((char*)text2, MAS2, nick);

/*	char text3[256] = " ? ?"; */

	sprintf((char*)text4, MAS4, nick);

	sprintf((char*)text5, MAS5, text);

	sprintf((char*)text6, MAS6, nick, text);

	sprintf((char*)text7, MAS7, nick);

/*	char text8[256] = "    ."; */

	putlog(LOG_CMDS, "*", "pub:massage [%s: %s] %s", nick, channel, text);
	on_pub_social(MAS1, text2, MAS3, text4, text5, text6, text7, MAS8, nick, channel, text);

	return(0);
}

/* TICKLE */
static int on_pub_tickle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ,  !"; */

	sprintf((char*)text2, TIC2, nick);

/*	char text3[256] = " ?"; */

	sprintf((char*)text4, TIC4, nick);

	sprintf((char*)text5, TIC5, text);

	sprintf((char*)text6, TIC6, nick, text);

	sprintf((char*)text7, TIC7, nick);

/*	char text8[256] = "?"; */

	putlog(LOG_CMDS, "*", "pub:tickle [%s: %s] %s", nick, channel, text);
	on_pub_social(TIC1, text2, TIC3, text4, text5, text6, text7, TIC8, nick, channel, text);

	return(0);
}

/* PAT */
static int on_pub_pat(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ,  ."; */

	sprintf((char*)text2, PAT2, nick);

/*	char text3[256] = " ?"; */

	sprintf((char*)text4, PAT4, nick);

	sprintf((char*)text5, PAT5, text);

	sprintf((char*)text6, PAT6, nick, text);

	sprintf((char*)text7, PAT7, nick);

/*	char text8[256] = ", , ?"; */

	putlog(LOG_CMDS, "*", "pub:pat [%s: %s] %s", nick, channel, text);
	on_pub_social(PAT1, text2, PAT3, text4, text5, text6, text7, PAT8, nick, channel, text);

	return(0);
}

/* CURSE */
static int on_pub_curse(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ."; */

	sprintf((char*)text2, CRS2, nick);

/*	char text3[256] = "    ."; */

	sprintf((char*)text4, CRS4, nick);

	sprintf((char*)text5, CRS5, text);

	sprintf((char*)text6, CRS6, nick, text);

	sprintf((char*)text7, CRS7, nick);

/*	char text8[256] = "    ,    ."; */

	putlog(LOG_CMDS, "*", "pub:curse [%s: %s] %s", nick, channel, text);
	on_pub_social(CRS1, text2, CRS3, text4, text5, text6, text7, CRS8, nick, channel, text);

	return(0);
}

/* ROLL */
static int on_pub_roll(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "      ."; */

	sprintf((char*)text2, RLL2, nick);

/*	char text3[256] = "    ."; */

	sprintf((char*)text4, RLL4, nick);

	sprintf((char*)text5, RLL5, text);

	sprintf((char*)text6, RLL6, nick, text);

	sprintf((char*)text7, RLL7, nick);

/*	char text8[256] = "     ?"; */

	putlog(LOG_CMDS, "*", "pub:roll [%s: %s] %s", nick, channel, text);
	on_pub_social(RLL1, text2, RLL3, text4, text5, text6, text7, RLL8, nick, channel, text);

	return(0);
}

/* TIP */
static int on_pub_tip(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "       ."; */

	sprintf((char*)text2, TIP2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, TIP4, nick);

	sprintf((char*)text5, TIP5, text);

	sprintf((char*)text6, TIP6, nick, text);

	sprintf((char*)text7, TIP7, nick);

/*	char text8[256] = "     ?"; */

	putlog(LOG_CMDS, "*", "pub:tip [%s: %s] %s", nick, channel, text);
	on_pub_social(TIP1, text2, TIP3, text4, text5, text6, text7, TIP8, nick, channel, text);

	return(0);
}

/* STROKE */
static int on_pub_stroke(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = " , ?"; */

	sprintf((char*)text2, STK2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, STK4, nick);

	sprintf((char*)text5, STK5, text, text);

	sprintf((char*)text6, STK6, text);

	sprintf((char*)text7, STK7, nick);

/*	char text8[256] = "   ."; */

	putlog(LOG_CMDS, "*", "pub:stroke [%s: %s] %s", nick, channel, text);
	on_pub_social(STK1, text2, STK3, text4, text5, text6, text7, STK8, nick, channel, text);

	return(0);
}

/* CHUCKLE */
static int on_pub_chuckle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ,   ."; */

	sprintf((char*)text2, CHC2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, CHC4, nick);

	sprintf((char*)text5, CHC5, text);

	sprintf((char*)text6, CHC6, nick, text);

	sprintf((char*)text7, CHC7, nick);

/*	char text8[256] = "   p,    ."; */

	putlog(LOG_CMDS, "*", "pub:chuckle [%s: %s] %s", nick, channel, text);
	on_pub_social(CHC1, text2, CHC3, text4, text5, text6, text7, CHC8, nick, channel, text);

	return(0);
}

/* FART */
static int on_pub_fart(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    !"; */

	sprintf((char*)text2, FRT2, nick);

/*	char text3[256] = "   ?"; */

	sprintf((char*)text4, FRT4,nick, nick);

	sprintf((char*)text5, FRT5, text);

	sprintf((char*)text6, FRT6, nick, text, nick);

	sprintf((char*)text7, FRT7, nick);

/*	char text8[256] = "     !"; */

	putlog(LOG_CMDS, "*", "pub:fart [%s: %s] %s", nick, channel, text);
	on_pub_social(FRT1, text2, FRT3, text4, text5, text6, text7, FRT8, nick, channel, text);

	return(0);
}

/* FLIP */
static int on_pub_flip(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, FLP2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, FLP4, nick);

	sprintf((char*)text5, FLP5, text);

	sprintf((char*)text6, FLP6, nick, text);

	sprintf((char*)text7, FLP7, nick);

/*	char text8[256] = "     ."; */

	putlog(LOG_CMDS, "*", "pub:flip [%s: %s] %s", nick, channel, text);
	on_pub_social(FLP1, text2, FLP3, text4, text5, text6, text7, FLP8, nick, channel, text);

	return(0);
}

/* GASP */
static int on_pub_gasp(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "       !"; */

	sprintf((char*)text2, GSP2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, GSP4, nick);

	sprintf((char*)text5, GSP5, text);

	sprintf((char*)text6, GSP6, nick, text);

	sprintf((char*)text7, GSP7, nick);

/*	char text8[256] = "  ."; */

	putlog(LOG_CMDS, "*", "pub:gasp [%s: %s] %s", nick, channel, text);
	on_pub_social(GSP1, text2, GSP3, text4, text5, text6, text7, GSP8, nick, channel, text);

	return(0);
}

/* SLOVE */
static int on_pub_slove(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = ",   ,     ."; */

	sprintf((char*)text2, SLV2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, SLV4, nick);

	sprintf((char*)text5, SLV5, text);

	sprintf((char*)text6, SLV6, nick, text);

	sprintf((char*)text7, SLV7, nick);

/*	char text8[256] = ",    ."; */

	putlog(LOG_CMDS, "*", "pub:slove [%s: %s] %s", nick, channel, text);
	on_pub_social(SLV1, text2, SLV3, text4, text5, text6, text7, SLV8, nick, channel, text);

	return(0);
}

/* MOAN */
static int on_pub_moan(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ."; */

	sprintf((char*)text2, MOA2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, MOA4, nick);

	sprintf((char*)text5, MOA5, text);

	sprintf((char*)text6, MOA6, nick, text);

	sprintf((char*)text7, MOA7, nick);

/*	char text8[256] = " ."; */

	putlog(LOG_CMDS, "*", "pub:moan [%s: %s] %s", nick, channel, text);
	on_pub_social(MOA1, text2, MOA3, text4, text5, text6, text7, MOA8, nick, channel, text);

	return(0);
}

/* NIBBLE */
static int on_pub_nibble(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "     ???????????????????"; */

	sprintf((char*)text2, NBB2, nick, nick);

/*	char text3[256] = " ?"; */

	sprintf((char*)text4, NBB4, nick);

	sprintf((char*)text5, NBB5, text);

	sprintf((char*)text6, NBB6, nick, text);

	sprintf((char*)text7, NBB7, nick);

/*	char text8[256] = ",   ."; */

	putlog(LOG_CMDS, "*", "pub:nibble [%s: %s] %s", nick, channel, text);
	on_pub_social(NBB1, text2, NBB3, text4, text5, text6, text7, NBB8, nick, channel, text);

	return(0);
}

/* SING */
static int on_pub_sing(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "     ."; */

	sprintf((char*)text2, SIN2, nick);

/*	char text3[256] = "    (?)   ."; */

	sprintf((char*)text4, SIN4, nick);

	sprintf((char*)text5, SIN5, text);

	sprintf((char*)text6, SIN6, nick, text);

	sprintf((char*)text7, SIN7, nick);

/*	char text8[256] = "   ."; */

	putlog(LOG_CMDS, "*", "pub:sing [%s: %s] %s", nick, channel, text);
	on_pub_social(SIN1, text2, SIN3, text4, text5, text6, text7, SIN8, nick, channel, text);

	return(0);
}

/* SQUEEZE */
static int on_pub_squeeze(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  -   !"; */

	sprintf((char*)text2, SQZ2, nick);

/*	char text3[256] = ", ,  ???"; */

	sprintf((char*)text4, SQZ4, nick);

	sprintf((char*)text5, SQZ5, text);

	sprintf((char*)text6, SQZ6, nick, text);

	sprintf((char*)text7, SQZ7, nick);

/*	char text8[256] = ", ,  ???"; */

	putlog(LOG_CMDS, "*", "pub:squeeze [%s: %s] %s", nick, channel, text);
	on_pub_social(SQZ1, text2, SQZ3, text4, text5, text6, text7, SQZ8, nick, channel, text);

	return(0);
}

/* WIGGLE */
static int on_pub_wiggle(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ."; */

	sprintf((char*)text2, WGG2, nick);

/*	char text3[256] = "  ."; */

	sprintf((char*)text4, WGG4, nick);

	sprintf((char*)text5, WGG5, text);

	sprintf((char*)text6, WGG6, nick, text);

	sprintf((char*)text7, WGG7, nick);

/*	char text8[256] = " , ."; */

	putlog(LOG_CMDS, "*", "pub:wiggle [%s: %s] %s", nick, channel, text);
	on_pub_social(SQZ1, text2, WGG3, text4, text5, text6, text7, WGG8, nick, channel, text);

	return(0);
}

/* SNOWBALL */
static int on_pub_snowball(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "           ."; */

	sprintf((char*)text2, SNW2, nick);

/*	char text3[256] = "     ?"; */

	sprintf((char*)text4, SNW4, nick);

	sprintf((char*)text5, SNW5, text);

	sprintf((char*)text6, SNW6, nick, text);

	sprintf((char*)text7, SNW7, nick);

/*	char text8[256] = "         ."; */

	putlog(LOG_CMDS, "*", "pub:snowball [%s: %s] %s", nick, channel, text);
	on_pub_social(SNW1, text2, SNW3, text4, text5, text6, text7, SNW8, nick, channel, text);

	return(0);
}

/* PRAY */
static int on_pub_pray(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = ",   ..."; */

	sprintf((char*)text2, PRY2, nick);

/*	char text3[256] = "   ...    ."; */

	sprintf((char*)text4, PRY4, nick);

	sprintf((char*)text5, PRY5, text);

	sprintf((char*)text6, PRY6, nick, text);

	sprintf((char*)text7, PRY7, nick);

/*	char text8[256] = "   ,     ."; */

	putlog(LOG_CMDS, "*", "pub:pray [%s: %s] %s", nick, channel, text);
	on_pub_social(PRY1, text2, PRY3, text4, text5, text6, text7, PRY8, nick, channel, text);

	return(0);
}

/* BEG */
static int on_pub_beg(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "     ?    ."; */

	sprintf((char*)text2, BEG2, nick);

/*	char text3[256] = "    ."; */

	sprintf((char*)text4, BEG4, nick);

	sprintf((char*)text5, BEG5, text);

	sprintf((char*)text6, BEG6, nick, text);

	sprintf((char*)text7, BEG7, nick);

/*	char text8[256] = "  ."; */

	putlog(LOG_CMDS, "*", "pub:beg [%s: %s] %s", nick, channel, text);
	on_pub_social(BEG1, text2, BEG3, text4, text5, text6, text7, BEG8, nick, channel, text);

	return(0);
}

/* CRINGE */
static int on_pub_cringe(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = " ?"; */

	sprintf((char*)text2, CRN2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, CRN4, nick);

	sprintf((char*)text5, CRN5, text);

	sprintf((char*)text6, CRN6, nick, text);

	sprintf((char*)text7, CRN7, nick);

/*	char text8[256] = "       .    ?"; */

	putlog(LOG_CMDS, "*", "pub:cringe [%s: %s] %s", nick, channel, text);
	on_pub_social(CRN1, text2, CRN3, text4, text5, text6, text7, CRN8, nick, channel, text);

	return(0);
}

/* FUME */
static int on_pub_fume(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  p -  !"; */

	sprintf((char*)text2, FUM2, nick);

/*	char text3[256] = "!   ,  ."; */

	sprintf((char*)text4, FUM4, nick);

	sprintf((char*)text5, FUM5, text);

	sprintf((char*)text6, FUM6, nick, text);

	sprintf((char*)text7, FUM7, nick);

/*	char text8[256] = "...   ."; */

	putlog(LOG_CMDS, "*", "pub:fume [%s: %s] %s", nick, channel, text);
	on_pub_social(FUM1, text2, FUM3, text4, text5, text6, text7, FUM8, nick, channel, text);

	return(0);
}

/* GROVEL */
static int on_pub_grovel(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "    ?"; */

	sprintf((char*)text2, GRV2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, GRV4, nick);

	sprintf((char*)text5, GRV5, text);

	sprintf((char*)text6, GRV6, nick, text);

	sprintf((char*)text7, GRV7, nick);

/*	char text8[256] = "       ."; */

	putlog(LOG_CMDS, "*", "pub:grovel [%s: %s] %s", nick, channel, text);
	on_pub_social(GRV1, text2, GRV3, text4, text5, text6, text7, GRV8, nick, channel, text);

	return(0);
}

/* NUDGE */
static int on_pub_nudge(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, NDG2, nick);

/*	char text3[256] = " ?"; */

	sprintf((char*)text4, NDG4, nick);

	sprintf((char*)text5, NDG5, text);

	sprintf((char*)text6, NDG6, nick, text);

	sprintf((char*)text7, NDG7, nick);

/*	char text8[256] = "-?"; */

	putlog(LOG_CMDS, "*", "pub:nudge [%s: %s] %s", nick, channel, text);
	on_pub_social(NDG1, text2, NDG3, text4, text5, text6, text7, NDG8, nick, channel, text);

	return(0);
}

/* SNARL */
static int on_pub_snarl(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   ."; */

	sprintf((char*)text2, SNR2, nick);

/*	char text3[256] = "     ."; */

	sprintf((char*)text4, SNR4, nick);

	sprintf((char*)text5, SNR5, text);

	sprintf((char*)text6, SNR6, nick, text);

	sprintf((char*)text7, SNR7, nick);

/*	char text8[256] = "   !"; */

	putlog(LOG_CMDS, "*", "pub:snarl [%s: %s] %s", nick, channel, text);
	on_pub_social(SNR1, text2, SNR3, text4, text5, text6, text7, SNR8, nick, channel, text);

	return(0);
}

/* SPANK */
static int on_pub_spank(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "  ......."; */

	sprintf((char*)text2, SPN2, nick);

/*	char text3[256] = " ?"; */

	sprintf((char*)text4, SPN4, nick);

	sprintf((char*)text5, SPN5, text);

	sprintf((char*)text6, SPN6, nick, text);

	sprintf((char*)text7, SPN7, nick);

/*	char text8[256] = "    !"; */

	putlog(LOG_CMDS, "*", "pub:spank [%s: %s] %s", nick, channel, text);
	on_pub_social(SPN1, text2, SPN3, text4, text5, text6, text7, SPN8, nick, channel, text);

	return(0);
}

/* HAND */
static int on_pub_hand(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = "   . ?"; */

	sprintf((char*)text2, HND2, nick);

/*	char text3[256] = "  ?"; */

	sprintf((char*)text4, HND4, nick);

	sprintf((char*)text5, HND5, text);

	sprintf((char*)text6, HND6, nick, text);

	sprintf((char*)text7, HND7, nick);

/*	char text8[256] = "      ."; */

	putlog(LOG_CMDS, "*", "pub:hand [%s: %s] %s", nick, channel, text);
	on_pub_social(HND1, text2, HND3, text4, text5, text6, text7, HND8, nick, channel, text);

	return(0);
}

/* YODEL */
static int on_pub_yodel(char *nick, char *uhost, char *hand, char *channel, char *text)
{
/*	char text1[256] = ",       - !"; */

	sprintf((char*)text2, YDL2, nick);

/*	char text3[256] = "   ."; */

	sprintf((char*)text4, YDL4, nick);

	sprintf((char*)text5, YDL5, text);

	sprintf((char*)text6, YDL6, nick, text);

	sprintf((char*)text7, YDL7, nick);

/*	char text8[256] = "    !"; */

	putlog(LOG_CMDS, "*", "pub:yodel [%s: %s] %s", nick, channel, text);
	on_pub_social(YDL1, text2, YDL3, text4, text5, text6, text7, YDL8, nick, channel, text);

	return(0);
}

static void social_report(int idx, int details)
{
	Context;
}

static cmd_t mypub[] =
{
	  /*  mask	   flags    function      tcl-name */

      {"!socmode", "", on_pub_socmode, "socmode"},
      {"!bounce", "", on_pub_bounce, "bounce"},
      {"!smile", "", on_pub_smile, "smile"},
      {"!dance", "", on_pub_dance, "dance"},
      {"!tango", "", on_pub_tango, "tango"},
      {"!cackle", "", on_pub_cackle, "cackle"},
      {"!laugh", "", on_pub_laugh, "laugh"},
      {"!giggle", "", on_pub_giggle, "giggle"},
      {"!shake", "", on_pub_shake, "shake"},
      {"!puke", "", on_pub_puke, "puke"},
      {"!growl", "", on_pub_growl, "growl"},
      {"!scream", "", on_pub_scream, "scream"},
      {"!comfort", "", on_pub_comfort, "comfort"},
      {"!sigh", "", on_pub_sigh, "sigh"},
/*    {"!sulk", "", on_pub_sulk, "sulk"}, */
      {"!hug", "", on_pub_hug, "hug"},
      {"!snuggle", "", on_pub_snuggle, "snuggle"},
      {"!cuddle", "", on_pub_cuddle, "cuddle"},
      {"!nuzzle", "", on_pub_nuzzle, "nuzzle"},
      {"!cry", "", on_pub_cry, "cry"},
      {"!poke", "", on_pub_poke, "poke"},
      {"!accuse", "", on_pub_accuse, "accuse"},
      {"!grin", "", on_pub_grin, "grin"},
      {"!bow", "", on_pub_bow, "bow"},
      {"!applaud", "", on_pub_applaud, "applaud"},
      {"!snicker", "", on_pub_snicker, "snicker"},
      {"!blush", "", on_pub_blush, "blush"},
      {"!burp", "", on_pub_burp, "burp"},
      {"!clap", "", on_pub_clap, "clap"},
      {"!curtsey", "", on_pub_curtsey, "curtsey"},
      {"!fondle", "", on_pub_fondle, "fondle"},
      {"!glare", "", on_pub_glare, "glare"},
      {"!groan", "", on_pub_groan, "groan"},
      {"!grope", "", on_pub_grope, "grope"},
      {"!lick", "", on_pub_lick, "lick"},
      {"!ruffle", "", on_pub_ruffle, "ruffle"},
      {"!shiver", "", on_pub_shiver, "shiver"},
      {"!shrug", "", on_pub_shrug, "shrug"},
      {"!hz", "", on_pub_hz, "hz"},
      {"!slap", "", on_pub_slap, "slap"},
      {"!smirk", "", on_pub_smirk, "smirk"},
      {"!snap", "", on_pub_snap, "snap"},
      {"!sniff", "", on_pub_sniff, "sniff"},
      {"!frown", "", on_pub_frown, "frown"},
      {"!whistle", "", on_pub_whistle, "whistle"},
      {"!ponder", "", on_pub_ponder, "ponder"},
      {"!stare", "", on_pub_stare, "stare"},
      {"!strut", "", on_pub_strut, "strut"},
      {"!thank", "", on_pub_thank, "thank"},
      {"!twiddle", "", on_pub_twiddle, "twiddle"},
      {"!wave", "", on_pub_wave, "wave"},
      {"!wink", "", on_pub_wink, "wink"},
      {"!french", "", on_pub_french, "french"},
      {"!comb", "", on_pub_comb, "comb"},
      {"!massage", "", on_pub_massage, "massage"},
      {"!tickle", "", on_pub_tickle, "tickle"},
      {"!pat", "", on_pub_pat, "pat"},
      {"!curse", "", on_pub_curse, "curse"},
      {"!roll", "", on_pub_roll, "roll"},
      {"!tip", "", on_pub_tip, "tip"},
      {"!stroke", "", on_pub_stroke, "stroke"},
      {"!chuckle", "", on_pub_chuckle, "chuckle"},
      {"!fart", "", on_pub_fart, "fart"},
      {"!flip", "", on_pub_flip, "flip"},
      {"!gasp", "", on_pub_gasp, "gasp"},
      {"!slove", "", on_pub_slove, "slove"},
      {"!moan", "", on_pub_moan, "moan"},
      {"!nibble", "", on_pub_nibble, "nibble"},
      {"!sing", "", on_pub_sing, "sing"},
      {"!squeeze", "", on_pub_squeeze, "squeeze"},
      {"!wiggle", "", on_pub_wiggle, "wiggle"},
      {"!snowball", "", on_pub_snowball, "snowball"},
      {"!pray", "", on_pub_pray, "pray"},
      {"!beg", "", on_pub_beg, "beg"},
      {"!cringe", "", on_pub_cringe, "cringe"},
      {"!fume", "", on_pub_fume, "fume"},
      {"!grovel", "", on_pub_grovel, "grovel"},
      {"!nudge", "", on_pub_nudge, "nudge"},
      {"!snarl", "", on_pub_snarl, "snarl"},
      {"!spank", "", on_pub_spank, "spank"},
      {"!hand", "", on_pub_hand, "hand"},
      {"!yodel", "", on_pub_yodel, "yodel"},
      {0}
};

static tcl_strings my_tcl_strings[] =
{
	{"nick", botnick, NICKLEN, 0},
	{NULL, NULL, 0, 0}
};

static char *social_close()
{

	Context;
	rem_tcl_strings(my_tcl_strings);
	rem_builtins(H_pub, mypub); 
	del_lang_section("social");
	module_undepend("social");

	return(NULL);
}

EXPORT_SCOPE char *social_start();

static Function social_table[] =
{
	(Function) social_start,
	(Function) social_close,
	(Function) social_expmem,
	(Function) social_report,
};

char *social_start(Function *global_funcs)
{

	global = global_funcs;

	Context;

	module_register("social", social_table, 0, 3);

	if (!(channels_funcs = module_depend(MODULE_NAME, "channels", 1, 0)))
		return "You need the channels module to use the social module.";
		if (!module_depend("social", "eggdrop", 106, 0)) {
			module_undepend("social");
			return "This module requires Eggdrop 1.6.13 or later.";
		}

	H_pub = find_bind_table("pub");
	add_builtins(H_pub, mypub);
	add_tcl_strings(my_tcl_strings);

	/*
	 * Load the default personality.
	 */ 
	initudef(1, "nopubsocial", 1);
	initudef(1, "noquietsocial", 1);
	add_lang_section("social");

	putlog(LOG_MISC, "*", "social.mod v%s loaded.", MODULE_VERSION);
	return NULL;
}
